#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define X_SIZE 40
#define Y_SIZE 20
#define X_POSUN 5
#define Y_POSUN 3
#define P_MINE 50
// mozna bude min o trochu mene, protoze se vygeneruji na stejne misto

int pole1[X_SIZE][Y_SIZE];
int x_pos=0, y_pos=0;

void tcol(int tcol, int bcol)
{
  textcolor (tcol);
  textbackground (bcol);
}

void init_pole()
{
  int ix1,ix2;

  for (ix2=0; ix2<Y_SIZE; ix2++)
  for (ix1=0; ix1<X_SIZE; ix1++)
  {
    pole1[ix1][ix2]=0; //4
  }

  for (ix1=0; ix1<P_MINE; ix1++)
  {
    pole1[random(X_SIZE-1)][random(Y_SIZE-1)]=1;
  }
}

void show_pole()
{
  int ix1,ix2;

  for (ix2=0; ix2<Y_SIZE; ix2++)
  for (ix1=0; ix1<X_SIZE; ix1++)
  {
    switch (pole1[ix1][ix2])
    {
      case 0 : pole1[ix1][ix2]=4; break;
      case 1 : pole1[ix1][ix2]=5; break;
      case 2 : pole1[ix1][ix2]=4; break;
      case 3 : pole1[ix1][ix2]=5; break;
    }
  }
}

int check_pole()
{
  int ix1,ix2,ix3;

  ix3=0;

  for (ix2=0; ix2<Y_SIZE; ix2++)
  for (ix1=0; ix1<X_SIZE; ix1++)
  {
    switch (pole1[ix1][ix2])
    {
      case 0 : ix3=1; break;
      case 2 : ix3=1; break;
    }
  }

  return ix3;
}


char field_num(int x, int y)
{
  int ix1,ix2,ix3,ix4,ix5,ix6,ix7=0;

  ix3=x-1; if (ix3<0) ix3=0;
  ix4=y-1; if (ix4<0) ix4=0;

  ix5=x+1; if (ix5>=X_SIZE) ix5=(X_SIZE-1);
  ix6=y+1; if (ix6>=Y_SIZE) ix6=(Y_SIZE-1);

  for (ix2=ix4; ix2<(ix6+1); ix2++)
  for (ix1=ix3; ix1<(ix5+1); ix1++)
  {
    //gotoxy ((ix1+X_POSUN),(ix2+Y_POSUN)); cprintf("=");
    if ( (pole1[ix1][ix2]==1) || (pole1[ix1][ix2]==3) || (pole1[ix1][ix2]==5) )
    {
      ix7++;
    }
  }

  return (ix7);
}

void field_numdraw(int fnum)
{
  switch (fnum)
  {
    case 0 : textcolor(7); cprintf(" "); break; // cerna
    case 1 : textcolor(9); cprintf("1"); break; // modra
    case 2 : textcolor(10); cprintf("2"); break; // zelena
    case 3 : textcolor(4); cprintf("3"); break; // cervena
    case 4 : textcolor(11); cprintf("4"); break;
    case 5 : textcolor(13); cprintf("5"); break;
    case 6 : textcolor(15); cprintf("6"); break;
    case 7 : textcolor(15); cprintf("7"); break;
    case 8 : textcolor(15); cprintf("8"); break;
    case 9 : textcolor(15); cprintf("9"); break;
    default : textcolor(7); cprintf("X"); break; // vice jak 9 min (nemozne ;-)
  }
}

void display_field(int x, int y)
{
  if ( (x_pos==x) && (y_pos==y) ) { textbackground(15); }
                             else { textbackground(0); }

  gotoxy ((x+X_POSUN),(y+Y_POSUN));
  switch (pole1[x][y])
  {
    case 0 : textcolor(8); cprintf("x"); break;  // zakryto bez miny         [x]
    case 1 : textcolor(8); cprintf("x"); break;  // zakryto s minou          [X]
    case 2 : textcolor(14); cprintf("m"); break; // oznacena mina (bez miny) [m]
    case 3 : textcolor(14); cprintf("m"); break; // oznacena mina (s minou)  [M]
    case 4 : textcolor(7); field_numdraw(field_num(x,y)); break;  // odkryto bez miny
    case 5 : textcolor(12); cprintf(""); break; // odkryto s minou (== dead ;-)
  }
}

void rec_clear(int x, int y)
{
  if ( (x>=0) && (y>=0) && (x<X_SIZE) && (y<Y_SIZE) )
  {
    if (pole1[x][y]==0)
    {
      pole1[x][y]=4;
      if (field_num(x,y)==0)
      {
        if (pole1[(x-1)][y]==0) rec_clear((x-1),y);
        if (pole1[(x+1)][y]==0) rec_clear((x+1),y);
        if (pole1[x][(y-1)]==0) rec_clear(x,(y-1));
        if (pole1[x][(y+1)]==0) rec_clear(x,(y+1));
      }
    }
  }
}

void display_pole()
{
  int ix1,ix2;

  for (ix2=0; ix2<Y_SIZE; ix2++)
  for (ix1=0; ix1<X_SIZE; ix1++)
  {
    display_field(ix1,ix2);
  }
}

void main(void)
{
  int konec=1;
  char ch;

  clrscr();
  gotoxy (1,1); printf("Miny - (c)2001 by Jan Krupa (krupaj@mobilnews.cz)\n");
  randomize();

  init_pole();
  display_pole();

  while (konec)
  {
    ch=getch();
    switch (ch)
    {
      case 27 : konec=0; break;
     case 'm' : switch (pole1[x_pos][y_pos])
                {
                  case 0 : pole1[x_pos][y_pos]=2; break;
                  case 1 : pole1[x_pos][y_pos]=3; break;
                  case 2 : pole1[x_pos][y_pos]=0; break;
                  case 3 : pole1[x_pos][y_pos]=1; break;
                }
                break;
      case 32 : switch (pole1[x_pos][y_pos])
                {
                  case 0 : rec_clear(x_pos,y_pos); break; //pole1[x_pos][y_pos]=4; break;
                  case 1 : show_pole();
                           //pole1[x_pos][y_pos]=5;
                           break;
                }
                //pole1[x_pos][y_pos]
                break;
       case 0 : ch=getch();
                switch (ch)
                {
                  case 72 : y_pos--; break;
                  case 80 : y_pos++; break;
                  case 75 : x_pos--; break;
                  case 77 : x_pos++; break;
                }
                break;
    }
    if (x_pos<0) x_pos=0;
    if (y_pos<0) y_pos=0;
    if (x_pos>=X_SIZE) x_pos=(X_SIZE-1);
    if (y_pos>=Y_SIZE) y_pos=(Y_SIZE-1);
    display_pole();
    if (check_pole()==0) konec=0;
  }
  display_pole();
}
